import request from "@/utils/request";

const THIRDPARTYSTATIONINFO_BASE_URL = "/api/v1/policy-fee";

const BillingStrategyApi = {
  /** 获取第三方充电站信息分页数据 */
  getPage(data: ThirdPartyStationInfoForm) {
    return request<any, PageResult<ThirdPartyStationInfoPageVO[]>>({
      url: `${THIRDPARTYSTATIONINFO_BASE_URL}/getStationInfoPageByEquipment`,
      method: "post",
      data,
    });
  },
  /**
   * 获取充电站下拉选择信息
   */
  getChargingPileSelect() {
    return request<any>({
      url: `${THIRDPARTYSTATIONINFO_BASE_URL}/getPartyStationInfo`,
      method: "get",
    });
  },
  /**
   * 获取运营商下拉选择信息
   */
  getOperatorSelect() {
    return request<any>({
      url: `/api/v1/third-party-info/list`,
      method: "get",
    });
  },
  /**
   * 通过选择的站点获取策略信息并编辑
   * @param stationId(站点id ) salesType(销售类型（0、平台 1、企业 2、渠道方）) thirdPartyId（销售类型为1、2时必填） firmId(企业ID（销售类型为1时必填）关联c_firm_info 企业ID（销售类型为1时必填）关联c_firm_info)
   */
  getBillingStrategy(stationId: any, salesType: number, thirdPartyId: number, firmId: number) {
    return request<any, ThirdPartyStationInfoForm>({
      url: `${THIRDPARTYSTATIONINFO_BASE_URL}/getPolicyFee?stationId=${stationId}&salesType=${salesType}&thirdPartyId=${thirdPartyId}&firmId=${firmId}`,
      method: "get",
    });
  },
  /**
   * 获取企业下拉选择信息
   */
  getFirmSelect() {
    return request<any>({
      url: `/api/v1/firmInfo/list`,
      method: "get",
    });
  },
  /**
   * 获取渠道方下拉选择信息
   */
  getChannelSelect() {
    return request<any>({
      url: `${THIRDPARTYSTATIONINFO_BASE_URL}/getPartyStationInfoList`,
      method: "get",
    });
  },
  /**
   *新增/修改充电站信息策略信息
   */
  saveBillingStrategy(data: any) {
    return request({
      url: `${THIRDPARTYSTATIONINFO_BASE_URL}/addPolicyFee`,
      method: "post",
      data,
    });
  },

  /**
   * 设置提示语
   */
  setTips(data: any) {
    return request({
      url: `${THIRDPARTYSTATIONINFO_BASE_URL}/updateStationTips`,
      method: "post",
      data,
    });
  },

  /**
   * 获取第三方充电站信息表单数据
   *
   * @param stationId 站点信息ID
   * @param salesType 销售类型（0、平台 1、企业 2、渠道方）
   * @param firmId 企业ID（销售类型为1时必填）关联c_firm_info
   * @param thirdPartyId 销售类型为1、2时必填
   * @returns 第三方充电站信息表单数据
   */
  getFormData(stationId: any, salesType: any, firmId: any, thirdPartyId: any) {
    return request<any, ThirdPartyStationInfoForm>({
      url: `${THIRDPARTYSTATIONINFO_BASE_URL}/getPolicyFee?stationId=${stationId}&salesType=${salesType}&firmId=${firmId}&thirdPartyId=${thirdPartyId}`,
      method: "get",
    });
  },

  /**
   *  添加第三方充电站信息
   *
   *  @param data 第三方充电站信息表单数据
   */
  create(data: ThirdPartyStationInfoForm) {
    return request({
      url: `${THIRDPARTYSTATIONINFO_BASE_URL}`,
      method: "post",
      data,
    });
  },

  /**
   * 更新第三方充电站信息
   *
   * @param id 第三方充电站信息ID
   * @param data 第三方充电站信息表单数据
   */
  update(id: string, data: ThirdPartyStationInfoForm) {
    return request({
      url: `${THIRDPARTYSTATIONINFO_BASE_URL}/${id}`,
      method: "put",
      data,
    });
  },

  /**
   * 批量删除第三方充电站信息，多个以英文逗号(,)分割
   *
   * @param ids 第三方充电站信息ID字符串，多个以英文逗号(,)分割
   */
  deleteByIds(ids: string) {
    return request({
      url: `${THIRDPARTYSTATIONINFO_BASE_URL}/${ids}`,
      method: "delete",
    });
  },
};

export default BillingStrategyApi;

/** 第三方充电站信息分页查询参数 */
export interface ThirdPartyStationInfoPageQuery extends PageQuery {
  /** 充电站ID */
  stationId?: string;
  /** 充电站名称 */
  stationName?: string;
  /** 站点状态 */
  stationStatus?: number;
}

/** 第三方充电站信息表单对象 */
export interface ThirdPartyStationInfoForm {
  /** 充电站ID */
  stationId?: string;
  /** 充电站名称 */
  stationName?: string;
  /** 建设场所 */
  construction?: number;
  /** 营业时间 */
  busineHours?: string;
  /** 更新时间 */
  updateTime?: Date;
}

/** 第三方充电站信息分页对象 */
export interface ThirdPartyStationInfoPageVO {
  /** 充电站ID */
  stationId?: string;
  /** 充电站名称 */
  stationName?: string;
  /** 省市辖区编码 */
  areaCode?: string;
  /** 详细地址 */
  address?: string;
  /** 服务电话 */
  serviceTel?: string;
  /** 站点类型 */
  stationType?: number;
  /** 站点状态 */
  stationStatus?: number;
  /** 车位数量 */
  parkNums?: number;
  /** 建设场所 */
  construction?: number;
  /** 营业时间 */
  busineHours?: string;
  /** 更新时间 */
  updateTime?: Date;
}
